#!/usr/bin/perl
#
#           RiSearch
#
# web search engine, version 0.99.08
# (c) Sergej Tarasov, 2000-2001
#
# Homepage: http://risearch.org/
# email: risearch@risearch.org
# Last modified: 03.11.2001


use LWP::UserAgent;
use HTML::LinkExtor;
require './config.pl';


@to_visit = ();
push(@to_visit,@start_url);
%visited_url = ();


#DEFINE CONSTANTS
$cfn = 0;
$cwn = 0;
$kbcount = 0;

$code = "\${\$_[0]} =~ tr/-a-zA-Z$CAP_LETTERS$LOW_LETTERS$numbers/ /cs;";
$remove_non_alphabetic = eval "sub { $code }";

$code = "\${\$_[0]} =~ tr/A-Z$CAP_LETTERS/a-z$LOW_LETTERS/;";
$to_lower_case = eval "sub { $code }";

if (exists($ENV{'GATEWAY_INTERFACE'})) {print "Content-Type: text/plain\n\n"}

unless ( -e "db" && -d "db" ) {
    mkdir("db",0777) or &my_die("Died: could not create directory 'db' - $!");
    print "Directory 'db' created\n";
}
open FINFO, ">$FINFO" or &my_die("Died: could not open $FINFO");
open SITEWORDS, ">$SITEWORDS" or &my_die("Died: could not open $SITEWORDS");
binmode(SITEWORDS);
open WORD_IND, ">$WORD_IND" or &my_die("Died: could not open $WORD_IND");
binmode(WORD_IND);

$time1 = time;
@time=localtime($time1);
$time="$time[2]:$time[1]:$time[0]";
print "Scan started: $time\n";

&start_spider;

$time2 = time;
@time=localtime($time2);
$time="$time[2]:$time[1]:$time[0]";
print "Scan finished: $time\n";
print "Creating databases. Please wait, this can take several minuts.\n";

close(FINFO);

print "Writing SITEWORDS\n";
    $pos_sitewords = tell(SITEWORDS);
    $pos_word_ind  = tell(WORD_IND);
    $to_print_sitewords = "";
    $to_print_word_ind  = "";
    foreach $word (sort keys %words) {
    	$cwn++;
    	$words_word_dum = pack("NN",$pos_sitewords+length($to_print_sitewords),
    	                        $pos_word_ind+length($to_print_word_ind));
    	$to_print_sitewords .= "$word\x0A";
    	$to_print_word_ind .= pack("N",length($words{$word})/4).$words{$word};
    	$words{$word} = $words_word_dum;
    	if (length($to_print_word_ind) > 32000) {
    	    print SITEWORDS $to_print_sitewords;
    	    print WORD_IND  $to_print_word_ind;
    	    $to_print_sitewords = "";
    	    $to_print_word_ind  = "";
    	    $pos_sitewords = tell(SITEWORDS);
    	    $pos_word_ind  = tell(WORD_IND);
    	}
    };
    print SITEWORDS $to_print_sitewords;
    print WORD_IND  $to_print_word_ind;

close(SITEWORDS);
close(WORD_IND);


$time3 = time;
@time=localtime($time3);
$time="$time[2]:$time[1]:$time[0]";
print "Building HASH - $time\n";

    &build_hash;

$time4 = time;
@time=localtime($time4);
$time="$time[2]:$time[1]:$time[0]";
print "\nIndexing finished: $time\n";

@time=gmtime($time2-$time1);
$time="$time[2]:$time[1]:$time[0]";
print "\nScaning took $time sec.\n";

@time=gmtime($time3-$time2);
$time="$time[2]:$time[1]:$time[0]";
print "Writing words took $time sec.\n";

@time=gmtime($time4-$time3);
$time="$time[2]:$time[1]:$time[0]";
print "Building hash took $time sec.\n";

@time=gmtime($time4-$time1);
$time="$time[2]:$time[1]:$time[0]";
print "Total time: $time sec.\n";

print "\n$cfn files are indexed, $cwn unique words are stored in database\n";

#=====================================================================

sub start_spider {

while (1) {
    $get_url = shift @to_visit;
    if (exists($visited_url{$get_url})) { next }
    if ($get_url eq "") { last }
    
    $hdrs = new HTTP::Headers(Accept => 'text/html',
                              User-Agent => 'RiSpider/1.0');
    
    $url = new URI::URL($get_url);
    print "$get_url\n";

    $req = new HTTP::Request(GET, $url, $hdrs);
    $ua = new LWP::UserAgent;

    $resp = $ua->request($req);
    $BASE = $resp->base;
    print "$BASE\n";
    $visited_url{$get_url}++;
    if ( ($BASE ne $get_url)  &&  exists($visited_url{$BASE})) { print "Already visited\n\n"; next }
    if ($BASE ne $get_url) { $visited_url{$BASE}++ }

    if ($resp->is_success) {
        $data = $resp->content;
        &extract_links( $data );
        &index_file($data,$get_url);
    } else {
        print $resp->message;
    }
    print "Done\n\n";
}

}   # end sub start_spider

#=====================================================================

sub extract_links {
    my $data = shift;
    
    $parser = HTML::LinkExtor->new(undef,$BASE);
    $parser->parse($data)->eof;
    @links = $parser->links;

    foreach $linkarray (@links) {
        my @element = @$linkarray;
        my $el_type = shift @element;
        while (@element) {
            my ($attr_name, $attr_value) = splice(@element, 0, 2);
            my $new_link = $attr_value;
            my $skip_this_link = 1;
                foreach $allow_url (@allow_url) {
                    if ($new_link =~ /$allow_url/) { $skip_this_link = 0 }
                }
                if ($skip_this_link) { next }
            $new_link =~ s/[#?].*?$//;
            if ($new_link !~ /$file_ext/i && $new_link !~ /\/[^.]*?$/) { next }
            if ($new_link =~ /\/$no_index_dir\//) { next }
            if ($new_link =~ /$no_index_files/) { next }
            $attr_value =~ s/#.*?$//;
            if ($cut_default_filenames eq 'YES') { $attr_value =~ s|$default_filenames|/|io }
            
            if ($el_type eq "a" && $attr_name eq "href") {
            	push(@to_visit,$attr_value);
            }
            if ($el_type eq "frame" && $attr_name eq "src") {
            	push(@to_visit,$attr_value);
            }
        }
    }
}

#=====================================================================

sub index_file {
    $html_text=$_[0];
    my $url=$_[1];

    $non_parse = 0;
    if ($url =~ m|$non_parse_ext$|io) {$non_parse++}
    $size = int length($html_text)/1024;
    $kbcount += $size;
    $cfn++;
    print "$cfn -> $filename; totalsize -> $kbcount\n";

# Delete parts of document, which should not be indexed
    foreach $key (keys %no_index_strings) {
    	$val = $no_index_strings{$key};
        $html_text =~ s/$key.*?$val/ /gs; 
    }

    if ($non_parse == 0) {
        $html_text =~ s/<!--.*?-->/ /gs;
        $html_text =~ s/<[Ss][Cc][Rr][Ii][Pp][Tt].*?<\/[Ss][Cc][Rr][Ii][Pp][Tt]>/ /gs;
        $html_text =~ s/<[Ss][Tt][Yy][Ll][Ee].*?<\/[Ss][Tt][Yy][Ll][Ee]>/ /gs;

        $html_text =~ s#<[Tt][Ii][Tt][Ll][Ee]>\s*(.*?)\s*</[Tt][Ii][Tt][Ll][Ee]># #s;
        $title = $1;
        $title =~ s/\s+/ /gs;
        $TITLE = $title;
        if ($truncate_title eq "YES") { $TITLE = substr($TITLE,0,64) }
        if ($TITLE eq "") {$TITLE = "No title"};

        if ($use_META eq "YES") { ($keywords,$description) = &get_META_info(\$html_text) }
        if ($use_ALT eq "YES") {
    	     $alt = join " ", ($html_text =~ m/<[Ii][Mm][Gg][^>]+[Aa][Ll][Tt]="([^"]*)"[^>]*>/gs );
        }
        if ($del_hyphen eq "YES") { &del_hyphen(\$html_text) }
        $html_text =~ s/<[^>]*>/ /gs;
        if ($use_esc eq "YES") { $html_text =~ s/(&.*?;)/&esc2char($1)/egs; }
        $html_text =~ s/\s+/ /gs;
        if (($use_META_descr eq "YES") & ($description ne "")) {
            $descript = substr($description,0,$descr_size);
        } else {
            (my $dum = substr($html_text,0,1024)) =~ s/\s+/ /gs;
            $descript = substr($dum,0,$descr_size);
        }
        $html_text .= " ".$title." ".$keywords." ".$decription." ".$alt;
    } else {
    	$html_text =~ s/\s+/ /gs;
        $title = "No title";
        $descript = substr($html_text,0,$descr_size);
    }
    
    &$remove_non_alphabetic(\$html_text);
    &$to_lower_case(\$html_text);
    $wwd = join " ", ($html_text =~ m/([^- ]+-[^ ]+[^- ])/gs);
    $html_text =~ tr/-/ /;
    $html_text .= " ".$wwd;
    $pos = pack("N",tell(FINFO));
    $TITLE =~ s/:+/:/g;
    $descript =~ s/:+/:/g;
    print FINFO $url,"::",$size,"::",$TITLE,"::",$descript,"\n";
    
    my %seen = ();
    @seen{split (/\s+/,$html_text)} = ();
    foreach (keys %seen) {
        if (length($_) < $min_length) { next }
        if (exists($stop_words{$_})) { next }
        $words{$_}.= $pos;
    }

};     # sub index_file
#=====================================================================

sub build_hash {

    for ($i=0; $i<$HASHSIZE; $i++) {$hash_array[$i] = ""};
    foreach $word (sort keys %words) {
        if ($INDEXING_SCHEME == 3) { $subbound = length($word)-3 }
        else { $subbound = 1 }
        if (length($word)==3) {$subbound = 1}
        $substring_length = 4;
        if ($INDEXING_SCHEME == 1) { $substring_length = length($word) }
        
        for ($i=0; $i<$subbound; $i++){
    	    $hash_value = &hash(substr($word,$i,$substring_length));
    	    $hash_array[$hash_value] .= ($words{$word});
    	};   # for $i
    };   # foreach $word
    
    open HASH, ">$HASH" or &my_die("Died: could not open $HASH");
    binmode(HASH);
    open HASHWORDS, ">$HASHWORDS" or &my_die("Died: could not open $HASHWORDS");
    binmode(HASHWORDS);

    $zzz = pack("N", 0);
    print HASHWORDS $zzz;
    $pos_hashwords  = tell(HASHWORDS);
    $to_print_hash = "";
    $to_print_hashwords = "";
    for ($i=0; $i<$HASHSIZE; $i++){
    	
        if ($hash_array[$i] eq "") {$to_print_hash .= $zzz};
        if ($hash_array[$i] ne "") {
            $to_print_hash .= pack("N",$pos_hashwords + length($to_print_hashwords));
            $to_print_hashwords .= pack("N", length($hash_array[$i])/8).$hash_array[$i]
        };   
        if (length($to_print_hashwords) > 64000) {
            print HASH $to_print_hash;
            print HASHWORDS $to_print_hashwords;
            $to_print_hash = "";
            $to_print_hashwords = "";
            $pos_hashwords  = tell(HASHWORDS);
        }
    }; # for $i
    print HASH $to_print_hash;
    print HASHWORDS $to_print_hashwords;
    
close(HASH);
close(HASHWORDS);

};     # sub build_hash
#=====================================================================

sub get_META_info {
    my ($html) = @_;
    $keywords    = ($$html =~ s/<[Mm][Ee][Tt][Aa]\s*[Nn][Aa][Mm][Ee]=\"?[Kk][Ee][Yy][Ww][Oo][Rr][Dd][Ss]\"?\s*[Cc][Oo][Nn][Tt][Ee][Nn][Tt]=\"?([^\"]*)\"?>//s) ? $1 : '';
    $description = ($$html =~ s/<[Mm][Ee][Tt][Aa]\s*[Nn][Aa][Mm][Ee]=\"?[Dd][Ee][Ss][Cc][Rr][Ii][Pp][Tt][Ii][Oo][Nn]\"?\s*[Cc][Oo][Nn][Tt][Ee][Nn][Tt]=\"?([^\"]*)\"?>//s) ? $1 : '';
    return ($keywords, $description)
}
#=====================================================================

sub del_hyphen {
    my ($text) = @_;
    local $/;
    $$text =~ s/-\n//gs;
}
#=====================================================================

sub my_die {
   my ($str) = @_;
   print "$str\n";
   die
}
#===================================================================
